import javax.swing.*;
import java.awt.*;
import java.awt.color.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.awt.image.*;
import java.io.*;
import java.lang.String.*;
import com.sun.image.codec.jpeg.*;
import java.beans.*;
import java.net.URL;
import java.util.Hashtable;
import javax.swing.event.*;


public class ImageManipulator extends JFrame implements ActionListener {

        public int                      i = 0;
        private JMenuBar                menuBar;
        private JMenu                   fileMenu,editMenu,viewMenu,
                                        transformMenu,extrasMenu,
                                        helpMenu, animatedMenu;

        private JMenuItem               newItem,loadimageItem,loadanimatedItem,saveimageItem,
                                        saveanimatedItem,exitItem,
                                        animationItem;

        private JMenuItem               addItem, delayItem, stopItem, stoprecordingItem,
                                        continueItem;

        private JMenuItem               zoominItem,zoomoutItem;

        private JMenuItem               scaleItem,fliphorizontalItem,rotateimageItem,
                                        shearItem,waveItem,translateItem,
                                        resetItem;

        private JMenuItem               brightnessItem,dbrightnessItem,blurItem,findedgesItem,
                                        grayItem,sharpenItem,negativeItem,aboutItem;

        private KeyStroke               ks;
        private Container               c;
        private Toolkit                 tk;
        private Dimension               d, d1, d2;
        private JToolBar                tb;
        private JButton                 b1,b2,b3,b4,b5,b6;
        private JDesktopPane            jd;
        private ImageProcessingPanel    panel[] = new ImageProcessingPanel[100];
        public JInternalFrame           iframe[] = new JInternalFrame[100];
        String                          pic;

        public static void main(String args[])
        {
                new ImageManipulator().show();
        }

        public ImageManipulator()
        {
                super("Image Manipulator");
                jd = new JDesktopPane();
                c = getContentPane();
                c.add(jd);
                addWindowListener(new Terminate());

                tk = Toolkit.getDefaultToolkit();
                d = tk.getScreenSize();
                setSize(d.width, d.height);

                menuBar = new JMenuBar();
                setJMenuBar(menuBar);

                fileMenu = new JMenu("File");
                fileMenu.setMnemonic('F');

              
                viewMenu = new JMenu("View");
                viewMenu.setMnemonic('V');

                transformMenu = new JMenu("Transform");
                transformMenu.setMnemonic('T');

                extrasMenu = new JMenu("Extras");
                extrasMenu.setMnemonic('X');

                helpMenu = new JMenu("Help");
                helpMenu.setMnemonic('H');

        //  add items to file menu
                newItem=new JMenuItem("New",new ImageIcon("new.gif"));
                ks=KeyStroke.getKeyStroke(KeyEvent.VK_N,InputEvent.CTRL_MASK);
                newItem.setAccelerator(ks);
                newItem.addActionListener(this);
                fileMenu.add(newItem);

                loadimageItem=new JMenuItem("Load Image");
                loadimageItem.addActionListener(this);
                fileMenu.add(loadimageItem);

                loadanimatedItem=new JMenuItem("Load Animated Image");
                loadanimatedItem.addActionListener(this);
                fileMenu.add(loadanimatedItem);
                
                saveimageItem=new JMenuItem("Save Image");
                ks=KeyStroke.getKeyStroke(KeyEvent.VK_S,InputEvent.CTRL_MASK);
                saveimageItem.setAccelerator(ks);
                saveimageItem.addActionListener(this);
                fileMenu.add(saveimageItem);

                saveanimatedItem=new JMenuItem("Save Animated Image");
                saveanimatedItem.addActionListener(this);
                fileMenu.add(saveanimatedItem);
                                 
                exitItem = new JMenuItem("Exit");
                ks = KeyStroke.getKeyStroke(KeyEvent.VK_X, InputEvent.CTRL_MASK);
                exitItem.setAccelerator(ks);
                exitItem.addActionListener(this);
                fileMenu.add(exitItem);

                menuBar.add(fileMenu);

             

        // add items to Animated menu
                animatedMenu = new JMenu("Animation");

                addItem = new JMenuItem("Start Recording");
                addItem.addActionListener(this);
                animatedMenu.add(addItem);

                
                stoprecordingItem = new JMenuItem("Stop Recording");
                stoprecordingItem.addActionListener(this);
                animatedMenu.add(stoprecordingItem);

                stopItem = new JMenuItem("Stop Animation");
                stopItem.addActionListener(this);
                animatedMenu.add(stopItem);

                continueItem = new JMenuItem("Continue Animation");
                continueItem.addActionListener(this);
                animatedMenu.add(continueItem);
                                
                menuBar.add(animatedMenu);

        // add items to View menu
                zoominItem = new JMenuItem("Zoom In");
                zoominItem.addActionListener(this);
                viewMenu.add(zoominItem);

                zoomoutItem = new JMenuItem("Zoom Out");
                zoomoutItem.addActionListener(this);
                viewMenu.add(zoomoutItem);

                menuBar.add(viewMenu);

        //  add items to transform Menu
                
                shearItem = new JMenuItem("Shear");
                shearItem.addActionListener(this);
                transformMenu.add(shearItem);

                translateItem = new JMenuItem("Translate");
                translateItem.addActionListener(this);
                transformMenu.add(translateItem);

                resetItem = new JMenuItem("Reset");
                resetItem.addActionListener(this);
                transformMenu.add(resetItem);
                            
                fliphorizontalItem = new JMenuItem("Flip Image");
                fliphorizontalItem.addActionListener(this);
                transformMenu.add(fliphorizontalItem);

                
                rotateimageItem = new JMenuItem("Rotate Image ");
                rotateimageItem.addActionListener(this);
                transformMenu.add(rotateimageItem);
                                                                                                  
                menuBar.add(transformMenu);

        //  add items to Extras Menu
                brightnessItem = new JMenuItem("Brightness",new ImageIcon("bright.jpg"));
                brightnessItem.addActionListener(this);
                extrasMenu.add(brightnessItem);

                

                blurItem = new JMenuItem("Blur",new ImageIcon("blur.jpg"));
                blurItem.addActionListener(this);
                extrasMenu.add(blurItem);

                grayItem = new JMenuItem("Gray Scale",new ImageIcon("gray.jpg"));
                grayItem.addActionListener(this);
                extrasMenu.add(grayItem);


                findedgesItem = new JMenuItem("Find Edges",new ImageIcon("edgedet.jpg"));
                findedgesItem.addActionListener(this);
                extrasMenu.add(findedgesItem);

                sharpenItem = new JMenuItem("Sharpen",new ImageIcon("sharpen.jpg"));
                sharpenItem.addActionListener(this);
                extrasMenu.add(sharpenItem);

                negativeItem = new JMenuItem("Negative");
                negativeItem.addActionListener(this);
                extrasMenu.add(negativeItem);

                
                menuBar.add(extrasMenu);

        //  add items to help menu
                aboutItem = new JMenuItem("About");
                aboutItem.addActionListener(this);
                helpMenu.add(aboutItem);
                
                menuBar.add(helpMenu);

                addWindowListener(new Terminate());
                tb = new JToolBar();

                b1 = new JButton(new ImageIcon("new.gif"));
                b1.addActionListener(this);
                tb.add(b1);

                b2=new JButton(new ImageIcon("open.gif"));
                b2.addActionListener(this);
                tb.add(b2);

                b3=new JButton(new ImageIcon("save.gif"));
                b3.addActionListener(this);
                tb.add(b3);

                      
               
                c.add(tb, new BorderLayout().NORTH);
                d1 = tb.getSize();
                d2 = menuBar.getSize();
  }

        public void actionPerformed(ActionEvent e)
        {
                Object  s = e.getSource();

                if (s == exitItem)
                     {
                        Frame x = new Frame();
                        DialogBox d = new
                        DialogBox(x," EXIT DIALOG BOX ");
                        d.setVisible(true);
                      }
                else if ((s == b1)||(s==newItem)) 
                     {
                        iframe[i] = new JInternalFrame("Image#" + (i + 1), true, true, true, true);
                        iframe[i].setSize(d.width, d.height-d1.height-d2.height);
                        panel[i] = new ImageProcessingPanel();
                        panel[i].setBackground(Color.white);
                        iframe[i].getContentPane().add(panel[i]);
                        jd.add(iframe[i]);
                        iframe[i].show();
                        ++i;
                     }   
                else if((s == saveimageItem) || (s == b3) )panel[i-1].saveasimage();
                else if(s == saveanimatedItem) panel[i-1].save(0);
                else if(s == addItem) panel[i-1].save(3);
                else if(s == delayItem) panel[i-1].save(2);
                else if(s == loadanimatedItem) panel[i-1].loadanimatedimage();
                else if(s == stoprecordingItem) panel[i-1].save(1);
                else if(s == stopItem) panel[i-1].stop1();
                else if(s == continueItem) panel[i-1].continue1();
                else if(s == fliphorizontalItem) panel[i-1].fliph();
                else if(s == grayItem) panel[i-1].grayOut();

                else if((s == loadimageItem) || (s==b2))
             {  
              JFileChooser chooser=new JFileChooser();
              final PreviewPanel previewPanel= new PreviewPanel();
              chooser.setAccessory(previewPanel);
                  chooser.addPropertyChangeListener(new PropertyChangeListener() {
                  public void propertyChange(PropertyChangeEvent e) {
                           if(e.getPropertyName().equals(JFileChooser.SELECTED_FILE_CHANGED_PROPERTY)) {
                                File f=(File)e.getNewValue();
                                String sr=f.getPath(), suffix=null;

                                 int i = sr.lastIndexOf('.');
                                 if(i>0 && i<sr.length()-1)
                                      suffix=sr.substring(i+1).toLowerCase();
                                 if(suffix.equals("gif")||suffix.equals("jpg")||suffix.equals("jpeg"))
                                   previewPanel.previewer.configure(f);
                                 }
                            }
                   });

                chooser.setCurrentDirectory(new File("."));
                chooser.setFileFilter(new
                javax.swing.filechooser.FileFilter(){
                public boolean accept(File f)
                {
                  String name=f.getName().toLowerCase();
                  return name.endsWith(".gif")
                  || name.endsWith(".jpg")
                  || name.endsWith(".jpeg")
                  || f.isDirectory();
                }
                public String getDescription()
                {
                    return "Image Files";
                }
               });
               
               int r=chooser.showOpenDialog(this);
               if(r==JFileChooser.APPROVE_OPTION)
               {
                  String name=chooser.getSelectedFile().getAbsolutePath();
                 //filename=chooser.getSelectedFile().getAbsolutePath();
                   pic=name;
                   panel[i-1].loadImage(name);
               }
             }    

                else if(s == blurItem) panel[i-1].blur();
                else if(s == sharpenItem) panel[i-1].sharpen();
                else if(s == brightnessItem) panel[i-1].bright();
                else if(s == dbrightnessItem) panel[i-1].decbright();
                else if(s == findedgesItem) panel[i-1].edgeDetect();
                else if(s == rotateimageItem) panel[i-1].rotate();
                else if(s == negativeItem) panel[i-1].negetive();
                
                else if(s == translateItem) panel[i-1].translate();     
                else if(s == shearItem) panel[i-1].shear();
                else if(s == resetItem) panel[i-1].reset(pic); 
                else if(s == zoomoutItem) panel[i-1].zoomin();
                else if(s == zoominItem) panel[i-1].zoomout();   
                
                else if(s == aboutItem)
                
                   {
	 		JOptionPane.showMessageDialog(null,"        Ajay .N -1PI99CS003 \n      Mahesh .R - 1PI99CS038 \n        Computer Science \n           P.E.S.I.T   ","About 			                                                               us",JOptionPane.INFORMATION_MESSAGE);	
	             }

  }
                 
        class Terminate extends WindowAdapter
        {
                public void windowClosing(WindowEvent e)
                { System.exit(0);
                }
        }
}


 class ImageProcessingPanel extends JPanel implements ActionListener
 {
        private Timer t = new Timer(20, this);
        //private Timer t;
        int w, h, r[], dy;
        int flag;
        String file="";
        private BufferedImage image;
        private Image loadedImage;
        private MediaTracker traker;
        RandomAccessFile os = null;
        int delay;

        public void paintComponent(Graphics g)
        {  super.paintComponent(g);
           if(loadedImage != null)
           { g.drawImage(loadedImage, 0, 0, null);
           }
        }

        public void loadImage(String name)
        {
           loadedImage = Toolkit.getDefaultToolkit().getImage(name);
           traker = new MediaTracker(this);
           traker.addImage(loadedImage, 0);
           try
           { traker.waitForID(0);
           }catch(InterruptedException e) {}

           image = new BufferedImage(loadedImage.getWidth(null), loadedImage.getHeight(null), BufferedImage.TYPE_INT_RGB);
           Graphics2D g2 = image.createGraphics();
           g2.drawImage(loadedImage, 0, 0, null);
           repaint();
        }

        public void loadanimatedimage()
        {            
           Frame f = new Frame();
           FileDialog fd = new FileDialog(f, "Open");
           fd.show();

           String path = fd.getFile();
           String dir = fd.getDirectory();

           try
           { os = new RandomAccessFile(dir+path,"r");
           }catch(IOException e){ }

           t.start();
        }

        public void stop1()
        {  try
            {  t.stop();
              // os.close();
               return;
            } catch(Exception e){}
         }

         public void continue1()
         {
            t.start();
         }   

        
         public void actionPerformed(ActionEvent e)
         {
           Object s = e.getSource();

           if (s == t)
           {  int del;
              int pix[];

              try{
                   dy = os.readInt();
                   if(dy == -1) { os.seek(0); dy = os.readInt(); }
            
                   w = os.readInt();
                   h = os.readInt();
                 } catch(Exception e2){}

              r = new int[w*h];
              for(int i = 0; i < w*h; i++)
              {
                 try{
                      r[i] = os.readInt();
                    } catch(Exception e1){}
               }  

               pix = new int[w*h];
               for(int i = 0; i < w*h;i++)
                 pix[i] = r[i];

               loadedImage = createImage(new MemoryImageSource(w, h, pix, 0, w));
               image = new BufferedImage(loadedImage.getWidth(null), loadedImage.getHeight(null), BufferedImage.TYPE_INT_RGB);
               repaint();
           }
       }
     

      public void save(int flag)
      {
         
         
         if(flag == 2)
         {
            delay = 20;
         }
         else if(flag == 1)
              {
                try{
                     os = new RandomAccessFile(file,"rw");
                     os.seek(os.length());
                     os.writeInt(-1);
                     os.close();
                   } catch(IOException e){ System.out.println(e); }
              }
                
         else if(flag == 0)
              {
                Frame f = new Frame("aaa");
                FileDialog fd = new FileDialog(f, "Save",FileDialog.SAVE);
                fd.show();
                String path = fd.getFile();
                String dir = fd.getDirectory();
                file = dir + path;
                int w = 0, h = 0;
                //System.out.print("Delay"+delay);

                try{
                     os = new RandomAccessFile(file,"rw");
                     System.out.println("File created");
                   } catch(IOException e){ System.out.println(e); }

                w = image.getWidth();
                h = image.getHeight();
                int[] pix = new int[w*h];
                PixelGrabber pg = new PixelGrabber(loadedImage, 0, 0, w, h, pix, 0, w);
                
                try{
                     pg.grabPixels();
                   } catch(Exception e){}
               
                try{
                     os.writeInt(delay);
                     os.writeInt(w);
                     os.writeInt(h);

                     for(int i = 0; i < w*h ; i++)
                        os.writeInt(pix[i]);

                     os.close();
                   } catch(IOException e){ System.out.println(e); }
              
              }  
            
         else if(flag == 3)
              {
                try{
                     os = new RandomAccessFile(file,"rw");
                   } catch(IOException e) { System.out.println(e);  }

                int w = 0, h = 0;
                System.out.print("Delay"+delay);                                w = image.getWidth();
                h = image.getHeight();
                int[] pix = new int[w*h];
                PixelGrabber pg = new PixelGrabber(loadedImage, 0, 0, w, h, pix, 0, w);
                
                try{
                     pg.grabPixels();
                   } catch(Exception e){}
               
                try{
                     os.seek(os.length());
                     os.writeInt(delay);
                     os.writeInt(w);
                     os.writeInt(h);

                     for(int i = 0; i < w*h ; i++)
                         os.writeInt(pix[i]);
                     os.close();
                   } catch(IOException e){System.out.println(e);}
             }
  }

  private void filter(BufferedImageOp op)
  {
      BufferedImage filteredImage = new BufferedImage(image.getWidth(), image.getHeight(), image.getType());
      op.filter(image, filteredImage);
      loadedImage = filteredImage;
      image = filteredImage;
      repaint();
   }

   private void convolve(float[] elements)
   {
       Kernel kernel = new Kernel(3, 3, elements);
       ConvolveOp op = new ConvolveOp(kernel);
       filter(op);
   }
   public void saveasimage()
   {
        Frame f = new Frame("aaa");
        FileDialog fd = new FileDialog(f, "Save",FileDialog.SAVE);
        fd.show();       
        String file = fd.getFile();
        String path = fd.getDirectory();
        System.out.print(path + file);
        try{
            JPEGImageEncoder op = JPEGCodec.createJPEGEncoder(new FileOutputStream(path+file));
            op.encode(image);
       }catch(Exception e){}
   }


   public void blur()
   {
       float weight = 1.0f / 9.0f;
       float[] elements = new float[9];
       for(int i = 0; i < 9; i++)
          elements[i] = weight;
       convolve(elements);
    }

    public void sharpen()
    {
       float[] elements = { 0.0f, -1.0f, 0.0f, -1.0f, 5.f, -1.0f, 0.0f, -1.0f, 0.0f};
       convolve(elements);
    }

    void edgeDetect()
    {           
       float[] elements = { 0.0f, -1.0f, 0.0f, -1.0f, 4.f, -1.0f, 0.0f, -1.0f, 0.0f};
       convolve(elements);
    }

    void bright()
    {
       float a = 1.5f;
       float b = -20.0f;
       RescaleOp op = new RescaleOp(a, b, null);
       filter(op);
    }

    void decbright()
    {
       float a =  20.0f;
       float b =  1.5f;
       RescaleOp op = new RescaleOp(a, b, null);
       filter(op);
    }

   void grayOut()
   {
       ColorConvertOp colorConvert = new  ColorConvertOp(ColorSpace.getInstance(ColorSpace.CS_GRAY),null);
       filter(colorConvert);
   }

    void negetive()
    {
       byte negative[] = new byte[256];
       for(int i = 0; i < 256; ++i)
         negative[i] = (byte)(255 - i);
       ByteLookupTable table = new ByteLookupTable(0, negative);
       LookupOp op = new LookupOp(table, null);
       filter(op);
    }

    void rotate()
    {
       AffineTransform transform = AffineTransform.getRotateInstance(Math.toRadians(5), image.getWidth() / 2, image.getHeight() / 2);
       AffineTransformOp op = new AffineTransformOp(transform, AffineTransformOp.TYPE_BILINEAR);              
       filter(op);
    }

    void translate()
    { 
       AffineTransform transform = AffineTransform.getTranslateInstance(50, 50);
       AffineTransformOp op = new AffineTransformOp(transform, AffineTransformOp.TYPE_BILINEAR);             
       filter(op);
    }
	
    void shear()
    {
       AffineTransform transform = AffineTransform.getShearInstance(2, 2);
       AffineTransformOp op = new AffineTransformOp(transform, AffineTransformOp.TYPE_BILINEAR);              
       filter(op);
    }

    void reset(String name)
    {
       loadedImage = Toolkit.getDefaultToolkit().getImage(name);
       traker = new MediaTracker(this);
       traker.addImage(loadedImage, 0);
       try {
             traker.waitForID(0);
           } catch(InterruptedException e) {}
       image = new BufferedImage(loadedImage.getWidth(null), loadedImage.getHeight(null), BufferedImage.TYPE_INT_RGB);
       Graphics2D g2 = image.createGraphics();
       g2.drawImage(loadedImage, 0, 0, null);
       repaint();
    }   

    void zoomout()
    {
       double w = 1.2*image.getWidth();
       double h = 1.2*image.getHeight();
       BufferedImage enlargeImage = new BufferedImage((int)w, (int)h, image.getType());
       for(int y = 0; y < (int)h; ++y)
          for(int x = 0; x < (int)w; ++x)
             enlargeImage.setRGB(x, y, image.getRGB((int)(x/1.2),(int)(y/1.2)));
       image = enlargeImage;
       loadedImage = enlargeImage;
       repaint();
             
       Graphics2D g2 = image.createGraphics();
       g2.drawImage(enlargeImage, 0, 0, null);
       repaint();
    }

    void fliph()
    {
        int w = image.getWidth();
        int h = image.getHeight();
        int[] pix = new int[w*h]; 
        int[] pixels = new int[w*h];
        PixelGrabber pg = new PixelGrabber(image, 0, 0, w, h, pix, 0, w);
        try{
            pg.grabPixels();
        }catch(Exception e){}
        for(int i = 0; i < w*h; i++)
       pixels[w*h - i - 1] = pix[i];

       loadedImage = createImage(new MemoryImageSource(w, h, pixels, 0, w));
       Graphics2D g2 = image.createGraphics();
       g2.drawImage(loadedImage, 0, 0, null);
   

       repaint();
  }      

    void zoomin()
    {
       double w = 0.8*image.getWidth();
       double h = 0.8*image.getHeight();
       BufferedImage enlargeImage = new BufferedImage((int)w, (int)h, image.getType());
       for(int y = 0; y < (int)h; ++y)
          for(int x = 0; x < (int)w; ++x)
             enlargeImage.setRGB(x, y, image.getRGB((int)(x/0.8),(int)(y/0.8)));
       image = enlargeImage;
       loadedImage = enlargeImage;
       repaint();
             
       Graphics2D g2 = image.createGraphics();
       g2.drawImage(enlargeImage, 0, 0, null);
       repaint();
    }  
}


 class ImagePreviewer extends JLabel
{
        public void configure(File f)
        {
                Dimension size=getSize();
                Insets insets=getInsets();
                ImageIcon icon= new ImageIcon(f.getPath());
                setIcon(new ImageIcon(icon.getImage().getScaledInstance( size.width-insets.left-insets.right,size.height-insets.top-insets.bottom,Image.SCALE_SMOOTH)));
       }
}


class PreviewPanel extends JPanel
{
        ImagePreviewer previewer=new ImagePreviewer();
        public PreviewPanel()
        {
                 JLabel label= new JLabel("Image Previewer",SwingConstants.CENTER);
                 setPreferredSize(new Dimension(250,30));
                 setLayout(new BorderLayout());
                 setBorder(BorderFactory.createLoweredBevelBorder()); 
                 JScrollPane scroller = new JScrollPane(previewer); 
                 add(scroller, BorderLayout.CENTER); 
                 label.setBorder(BorderFactory.createEtchedBorder());
                 add(label,BorderLayout.NORTH);
                        



        }
}


class  DialogBox extends Dialog implements ActionListener
        {
                DialogBox(Frame parent , String title)
                  {
                        super(parent ,title,false);
                        setLayout(new FlowLayout(FlowLayout.CENTER,150,50));
                        setSize(500,200);
                        setLocation(300,200);
                        String msg = " Do you really want to exit ";
                        Font f = new Font(" msg ",Font.ITALIC,20);
                        setFont(f);

                        add(new Label (  msg ));
                        Button yes , no;
                        add(yes = new Button(" YES "));
                        add(no = new Button(" NO "));

                        yes.addActionListener(this);
                        no.addActionListener(this);
                  }

                  public void actionPerformed(ActionEvent ae)
                   {
                       String choice = (String)ae.getActionCommand();
                       if(choice.equals(" YES "))
                        {
                          System.exit(0);
                        }
                       else if(choice.equals(" NO "))
                        {
                          setVisible(false);
                        }
                    }
        }


 

